function InitNaturePack()
{
   echo("InitNaturePack()");
      
   // create the path to the nature paths sim group in the mission file
   // and get the sim group.
   %groupName = "MissionGroup/NaturePaths";
   %group = nameToID(%groupName);
   if (!isObject(%group))
   {
      echo("NaturePack Error: Could not find NaturePaths sim group!");
      return;
   }

   // get the number of paths in the sim group
   %pathcount = %group.getCount();
   if (%pathcount < 1)
   {
      echo("NaturePack Error: No paths in NaturePaths sim group!");
      return;
   }
   echo("NaturePack: Found " @ %pathcount @ " paths.");
   // iterate through all the paths. Create an AIPlayer for each path
   // using the datablock specified by the first marker's nature property.
   for (%pathindex=0; %pathindex<%pathcount; %pathindex++)
   {
      %path = %group.getObject(%pathindex);
      %markercount = %path.getCount();
      if (%markercount < 1)
      {
         echo("NaturePack Error: No markers in path!");
      }
      else
      {
         %marker = %path.getObject(0);
         %datablock = %marker.nature;
         %player = new AIPlayer() {
           dataBlock = %datablock;
           aiPlayer = true;
         };
         if (!isObject(%player))
         {
            echo("NaturePack Error: Failed to create " @ %marker.nature @ " for path " @ %pathindex @ "!");
            continue;
         }

         echo("NaturePack: Created " @ %marker.nature @ " for path " @ %pathindex @ ".");

         MissionCleanup.add(%player);
         %player.setMoveSpeed(1);
         %player.setEnergyLevel(1);
         %player.setShapeName(%this.name);

         // create an array of markers for the aiplayer
         for (%markerindex=0; %markerindex<%markercount; %markerindex++)
         {
            %player.marker[%markerindex] = %path.getObject(%markerindex);
         }
         %player.numMarkers = %markercount;
         %player.curMarker = 0;

         // get the aiplayer's first marker position
         %marker = %player.marker[%player.curMarker];
         %matrix = %marker.getTransform();

         // set the position and orientation and start the movement of the aiplayer
         %player.setTransform(%matrix); 
         %pos = getWords(%matrix, 0, 2);
         %player.setAimLocation(%pos);
         %player.setMoveDestination(%pos); 
      }
   }
}